SystemOrganization addCategory: #'SourceCity-OpenGL'!

!NBGLDisplay methodsFor: '*SourceCity-OpenGL' stamp: 'DouailleErwan 5/22/2012 11:27'!
readPixel: aPoint

      |  x y pixel |
	pixel := ByteArray new: 4.

	x := aPoint x asInteger.
	y := aPoint y asInteger.
	
	"Copy pixels from buffer into a form"
	self gl flush;
		pixelStorei_pname: GL_PACK_SKIP_ROWS param: 0;
		pixelStorei_pname: GL_PACK_SKIP_PIXELS param: 0;
		
		readPixels_x: x
		y: y
		width: 1  
		height: 1  
		format: GL_BGRA_EXT 
		type:  GL_UNSIGNED_BYTE 
		pixels: pixel.

	^ pixel
	! !

!NBMSAAOffscreenDisplay methodsFor: '*SourceCity-OpenGL' stamp: 'DouailleErwan 5/22/2012 11:35'!
readPixel: aPoint
	| r |

	renderFBO bindAsReadBuffer.
	resultsFBO bindAsDrawBuffer.
	
	self gl blitFramebuffer_srcX0: 0 srcY0:  0 srcX1: extent x srcY1: extent y 
		dstX0:  0 dstY0:  0 dstX1: extent x  dstY1: extent y mask: GL_COLOR_BUFFER_BIT filter: GL_NEAREST.
	
	resultsFBO bindAsReadBuffer.
		
	r := super readPixel: aPoint.
	^ r! !

GLViewportMorph subclass: #SourceCityGL
	instanceVariableNames: 'sourceCityConfiguration pickingBuf camera controller drawing userInterface renderer d frameCount t frameStats start timeCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGL commentStamp: '<historical>' prior: 0!
A GLCity is a class which display the city with OpenGL, this class use camera and key handler!

!SourceCityGL class methodsFor: 'as yet unclassified' stamp: 'blo 7/5/2012 13:28'!
sourceCityConfiguration: aSourceCityConfiguration
	^self new sourceCityConfiguration: aSourceCityConfiguration! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:16'!
camera
	^ camera! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
camera: anObject

	camera := anObject! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
controller

	^ controller! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
controller: anObject

	controller := anObject! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:18'!
display 
	^display! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
drawing

	^ drawing! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
drawing: anObject

	drawing := anObject! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:24'!
handleMouseMove: anEvent
	self controller handleMouseMove: anEvent
! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 7/30/2012 11:51'!
handlesMouseOver: anEvent
	^ true! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 7/12/2012 17:37'!
handlesMouseWheel: evt
	"Do I want to receive mouseWheel events?." 

	^true! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 7/9/2012 16:55'!
hasKeyboardFocus
	^true.! !

!SourceCityGL methodsFor: 'initialize' stamp: 'DouailleErwan 7/30/2012 14:31'!
initialize
	super initialize.
	
	self drawing: (SourceCityGLVizualisationBuilder initialize: self).
	self userInterface: (SourceCityUI initialize: self).
	self renderer: (SourceCityGLVizualisationRenderer initialize: self ).
	self controller: (SourceCityGLController initialize: self).
	
	self on: #keyStroke send: #captureKey: to: self controller.
	self on: #mouseDown send: #captureMouseDown: to: self controller.	
	"
	frameCount := 0.
	timeCounter := Stopwatch new activate ."! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 7/9/2012 17:02'!
mouseEnter: anEvent
	anEvent hand newKeyboardFocus: self! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:37'!
mouseLeave: anEvent
	anEvent hand newKeyboardFocus: nil! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 7/12/2012 17:43'!
mouseWheel: event 
	self controller captureMouseWheel: event.
	! !

!SourceCityGL methodsFor: 'initialize' stamp: 'DouailleErwan 7/29/2012 19:19'!
openInWorld
	self startStepping.
	self takeKeyboardFocus.
	self userInterface openInWorld.! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
pickingBuf

	^ pickingBuf! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
pickingBuf: anObject

	pickingBuf := anObject! !

!SourceCityGL methodsFor: 'rendering' stamp: 'DouailleErwan 7/30/2012 13:12'!
render
	self renderer render."
	Transcript cr;show:'Average FPS:', (( frameCount / ((timeCounter duration seconds) +((timeCounter duration minutes * timeCounter duration seconds)) +0.1)) asInteger )asString ."! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
renderer

	^ renderer! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
renderer: anObject

	renderer := anObject! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
sourceCityConfiguration

	^ sourceCityConfiguration! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:17'!
sourceCityConfiguration: anObject

	sourceCityConfiguration := anObject.
	self camera:(SourceCityGLCamera initialize: self camera: self sourceCityConfiguration camera). 
! !

!SourceCityGL methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 7/30/2012 14:46'!
step"
	frameCount := frameCount + 1."
	self changed! !

!SourceCityGL methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 7/30/2012 12:38'!
stepTime
	^1! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
userInterface

	^ userInterface! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
userInterface: anObject

	userInterface := anObject! !

GLViewportMorph subclass: #SourceCityGLVizualisationBuilder
	instanceVariableNames: 'sourceCityGL idDictionary id city glList glListPicking glListDependencies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLVizualisationBuilder commentStamp: 'blo 7/9/2012 11:11' prior: 0!
I manage how to create the city vizualisation.!

!SourceCityGLVizualisationBuilder class methodsFor: 'as yet unclassified' stamp: 'blo 7/9/2012 11:48'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:25'!
city
	city ifNil: [self city: sourceCityGL sourceCityConfiguration city].
	^ city! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:06'!
city: aCity
	city := aCity.
	self createIdDictionary: aCity! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/5/2012 14:25'!
colorFor: anElement
	| r g b |
	r := anElement color red.
	g := anElement color green.
	b := anElement color blue.
	display gl color3f_red: r green: g blue: b! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/5/2012 15:47'!
colorInPickingModeFor: anElement
	| elementId r g b |
	elementId := idDictionary keyAtValue: anElement.
	r := elementId bitAnd: 255.
	g := elementId >> 8 bitAnd: 255.  " elementId // (2^8) "
	b := elementId >>16 bitAnd: 255.
	display gl color3ub_red:  r green: g  blue:  b.! !

!SourceCityGLVizualisationBuilder methodsFor: 'buildList' stamp: 'DouailleErwan 7/13/2012 11:56'!
createDependenciesRenderingList
	self glListDependencies: (display gl genLists: 3).
	self fillRenderingList: self glListDependencies drawDependencies: self sourceCityGL renderer selectedElement.! !

!SourceCityGLVizualisationBuilder methodsFor: 'tools' stamp: 'blo 7/5/2012 15:00'!
createIdDictionary: aCity
	idDictionary := Dictionary new.
	idDictionary at: (self generateId) put: aCity.
	aCity districts do:[:aDistrict | idDictionary at: (self generateId) put: aDistrict.
		aDistrict buildings do: [:aBuilding | idDictionary at: (self generateId) put: aBuilding]].! !

!SourceCityGLVizualisationBuilder methodsFor: 'buildList' stamp: 'blo 7/9/2012 11:45'!
createLists
	self createNormalRenderingList.
	self createPickingRenderingList.! !

!SourceCityGLVizualisationBuilder methodsFor: 'buildList' stamp: 'blo 7/9/2012 11:42'!
createNormalRenderingList
	self glList: (display gl genLists: 1).
	self fillRenderingList: (self glList) pickingMode: false. ! !

!SourceCityGLVizualisationBuilder methodsFor: 'buildList' stamp: 'blo 7/9/2012 11:42'!
createPickingRenderingList
	self glListPicking: (display gl genLists: 2).
	self fillRenderingList: (self glListPicking) pickingMode: true. ! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/9/2012 11:49'!
disableOpenGLOption
	
	display gl 		
		enable: GL_MULTISAMPLE ;
		disable: GL_BLEND;
		disable: GL_POLYGON_SMOOTH;
		disable: GL_NORMALIZE;
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.		! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:48'!
drawBack: aPoint vector3D: aVector
	display gl begin: GL_QUADS;
		vertex3d_x:  aPoint x 
			y: aPoint y 
			z: (aPoint z)+(aVector z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: aPoint y 
			z: (aPoint z)+(aVector z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: aPoint y + (aVector y)
			z: (aPoint z)+(aVector z);
		vertex3d_x:  aPoint x 
			y: aPoint y + (aVector y)
			z: (aPoint z)+(aVector z);
	end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'DouailleErwan 7/17/2012 11:01'!
drawBezierLine: aPoint3D to: anotherPoint3D height: height
	
	| n x y z |
	display gl begin: GL_LINE_STRIP.
	n := 1.
	[ n > 0 ] whileTrue: [
		n := n -0.01.
		x := (((1-n) raisedTo: 3)*aPoint3D x) + (3*n*((1-n) raisedTo: 2)* aPoint3D x) + (3*(n raisedTo: 2)*(1-n)* anotherPoint3D x) + ((n raisedTo: 3)* anotherPoint3D x).
		y := (((1-n) raisedTo: 3)*aPoint3D y) + (3*n*((1-n) raisedTo: 2)* height) + (3*(n raisedTo: 2)*(1-n)* height) + ((n raisedTo: 3)* anotherPoint3D y).
		z := (((1-n) raisedTo: 3)*aPoint3D z) + (3*n*((1-n) raisedTo: 2)* aPoint3D z) + (3*(n raisedTo: 2)*(1-n)* anotherPoint3D z) + ((n raisedTo: 3)* anotherPoint3D z).
		display gl vertex3f_x: x y: y z: z.
		display gl vertex3f_x: x y: y z: z.
		].
	display gl end.
	! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:48'!
drawBorder: aPoint vector3D: aVector
	display gl begin: GL_LINE_STRIP;
		color3f_red: 0 green: 0 blue: 0; 
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y) 
			z: (aPoint z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z) + (aVector z);
		vertex3f_x: (aPoint x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z) + (aVector z);
		vertex3f_x: (aPoint x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3f_x: (aPoint x)
			y: (aPoint y)
			z: (aPoint z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y)
			z: (aPoint z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y)
			z: (aPoint z)+ (aVector z);
		vertex3f_x: (aPoint x)
			y: (aPoint y)
			z: (aPoint z)+ (aVector z);
		vertex3f_x: (aPoint x)
			y: (aPoint y)
			z: (aPoint z);
	end.
	display gl begin: GL_LINES;
		color3f_red: 0 green: 0 blue: 0; 
		vertex3f_x: (aPoint x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3f_x: (aPoint x)
			y: (aPoint y)
			z: (aPoint z) + (aVector z);
		vertex3f_x: (aPoint x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z) + (aVector z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y)
			z: (aPoint z) + (aVector z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z) + (aVector z);
		end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/9/2012 12:23'!
drawCityWithPicking: aBoolean
	self drawCube: self city pickingMode: aBoolean.
	self city districts do: [:aDistrict | self drawDistrict: aDistrict pickingMode: aBoolean].
	! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/9/2012 11:31'!
drawCube: anElement pickingMode: aBoolean
	| aPosition aDimension |
	aPosition := anElement absolutePosition.
	aDimension := anElement dimension.
	
	(aBoolean)
	ifTrue: [self colorInPickingModeFor: anElement] 
	ifFalse: [self colorFor: anElement].
	
	self drawFace: aPosition vector3D: aDimension.
	self drawBack: aPosition vector3D: aDimension.
	self drawLeft: aPosition vector3D: aDimension.
	self drawRight: aPosition vector3D: aDimension.
	self drawDown: aPosition vector3D: aDimension.
	self drawTop: aPosition vector3D: aDimension.
	
	(self pickingMode)
		ifFalse: [self drawBorder: aPosition vector3D: aDimension.].! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'DouailleErwan 7/30/2012 15:24'!
drawCubePicked: anElement
	| aPosition aDimension |
	aPosition := anElement absolutePosition.
	aDimension := anElement dimension.
	

	display gl color3f_red: 0.5 green: 0.5 blue: 1.
	self drawFace: aPosition vector3D: aDimension.
	self drawBack: aPosition vector3D: aDimension.
	self drawLeft: aPosition vector3D: aDimension.
	self drawRight: aPosition vector3D: aDimension.
	self drawDown: aPosition vector3D: aDimension.
	self drawTop: aPosition vector3D: aDimension.
	
	(self pickingMode)
		ifFalse: [self drawBorder: aPosition vector3D: aDimension.].! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/9/2012 11:33'!
drawDistrict: aDistrict pickingMode: aBoolean
	
	self drawCube: aDistrict pickingMode: aBoolean. 
	
	aDistrict buildings do:[:aBuilding |
		self drawCube: aBuilding pickingMode: aBoolean.
		]! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:50'!
drawDown: aPoint vector3D: aVector
	display gl begin: GL_QUADS;
		vertex3d_x:  (aPoint x) 
			y: (aPoint y) 
			z: (aPoint z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: (aPoint y)
			z: (aPoint z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: (aPoint y)
			z: (aPoint z)+(aVector z);
		vertex3d_x:  (aPoint x) 
			y: (aPoint y)
			z: (aPoint z)+(aVector z);
	end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:50'!
drawFace: aPoint vector3D: aVector
	display gl begin: GL_QUADS;
		vertex3d_x: (aPoint x) 
			y: (aPoint y) 
			z: (aPoint z);
		vertex3d_x: (aPoint x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3d_x: (aPoint x)+(aVector x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3d_x: (aPoint x)+(aVector x) 
			y: (aPoint y) 
			z: (aPoint z);
	end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'DouailleErwan 7/17/2012 11:53'!
drawInterDistrictLine: anElement to: anotherElement
	
	| heightCity heightAnElement heightAnotherElement |
	
	heightCity := 0.
	heightAnElement := 0.
	heightAnotherElement := 0.
	
	anElement district buildings do: [:building | (building absolutePosition y + building dimension y > heightAnElement)
		ifTrue: [heightAnElement := building absolutePosition y + building dimension y]].
	heightAnElement := heightAnElement *1.5.
	
	anElement district buildings do: [:building | (building absolutePosition y + building dimension y > heightAnotherElement)
		ifTrue: [heightAnotherElement := building absolutePosition y + building dimension y] ].
	heightAnotherElement := heightAnotherElement *1.5.
	
	anElement district city districts do: [:aDistrict | 
		aDistrict buildings do: [:building | (building absolutePosition y + building dimension y > heightCity)
			ifTrue: [heightCity := building absolutePosition y + building dimension y] ].
		].
	heightCity := heightCity * 1.5.
	
	display gl color3f_red: 0 green: 0 blue: 255.
	
	self drawBezierLine: (Point3D x: anElement absolutePosition x + (anElement dimension x /2)
			y: anElement absolutePosition y + anElement dimension y
			z: anElement absolutePosition z + (anElement dimension z /2))
		to: (Point3D x: anElement district absolutePosition x + (anElement district dimension x /2)
			y: heightAnElement
			z: anElement district absolutePosition z + (anElement district dimension z /2))
		height:  heightAnElement * 0.8 .
	
	self drawBezierLine: (Point3D x: anElement district absolutePosition x + (anElement district dimension x /2)
			y: heightAnElement-4
			z: anElement district absolutePosition z + (anElement district dimension z /2))
		to: (Point3D x: anotherElement district absolutePosition x + (anotherElement district dimension x /2)
			y: heightAnotherElement-4
			z: anotherElement district absolutePosition z + (anotherElement district dimension z /2))
		height:  heightCity .
	
	self drawBezierLine:  (Point3D x: anotherElement absolutePosition x + (anotherElement dimension x /2)
			y: anotherElement absolutePosition y + anotherElement dimension y
			z: anotherElement absolutePosition z + (anotherElement dimension z /2))
		to: (Point3D x: anotherElement district absolutePosition x + (anotherElement district dimension x /2)
			y: heightAnotherElement
			z: anotherElement district absolutePosition z + (anotherElement district dimension z /2))
		height:  heightAnotherElement*0.8 .
	! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:50'!
drawLeft: aPoint vector3D: aVector
	display gl begin: GL_QUADS;
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: (aPoint y)
			z: (aPoint z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z)+(aVector z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: (aPoint y)
			z: (aPoint z)+(aVector z);
	end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:50'!
drawRight: aPoint vector3D: aVector
	display gl begin: GL_QUADS;
		vertex3d_x:  (aPoint x) 
			y: (aPoint y)
			z: (aPoint z)+(aVector z);
		vertex3d_x:  (aPoint x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z)+(aVector z);
		vertex3d_x:  (aPoint x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z) ;
		vertex3d_x:  (aPoint x) 
			y: (aPoint y)
			z: (aPoint z) ;
	end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'DouailleErwan 7/23/2012 14:28'!
drawSameDistrictLine: anElement to: anotherElement
	| aStartPosition aFinalPosition n x y z height|
	height := 0.
	anElement district buildings do: [:building | (building absolutePosition y + building dimension y > height)
		ifTrue: [height := building absolutePosition y + building dimension y]].
	
	display gl color3f_red: 0 green: 0 blue: 255.
	
	self drawBezierLine: ( Point3D x: anElement absolutePosition x + (anElement dimension x /2)
			y: anElement absolutePosition y + anElement dimension y
			z: anElement absolutePosition z + (anElement dimension z /2))
		to: (Point3D x: anotherElement absolutePosition x + (anotherElement dimension x /2)
			y: anotherElement absolutePosition y + anotherElement dimension y
			z: anotherElement absolutePosition z + (anotherElement dimension z /2))
		height: height * 1.5.! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:50'!
drawTop: aPoint vector3D: aVector
	display gl begin: GL_QUADS;
		vertex3d_x: (aPoint x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z) ;
		vertex3d_x: (aPoint x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z)+(aVector z);
		vertex3d_x: (aPoint x)+(aVector x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z)+(aVector z);
		vertex3d_x: (aPoint x)+(aVector x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z) ;
	end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/9/2012 11:49'!
enableOpenGLOption
	
	display gl 		
		enable: GL_MULTISAMPLE ;
		enable: GL_BLEND;
		enable: GL_POLYGON_SMOOTH;
		enable: GL_NORMALIZE;
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		shadeModel: GL_SMOOTH;
		hint_target: GL_LINE_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_POLYGON_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_PERSPECTIVE_CORRECTION_HINT mode: GL_NICEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.		
	"save it there for the moment :)"
	"WORK !!!!!!!!"
	"specular := GLFloatRGBA new.
	specular r: 1; g: 1;b: 1; a:1. 
	shinines:= GLFloatRGBA new.
	shinines r: 500. 	
	l_pos := GLFloatVector new.
	l_pos x: 0 ;y: 0;z: 0. 
	l_color := GLFloatRGBA new.
	l_color r: 1; g: 1;b: 1; a:1. 			
	lmodel_ambient := GLFloatRGBA new.
	lmodel_ambient r: 1;g: 1 ;b: 1; a:1."
	
	"fog_color := GLFloatRGBA new.
	fog_color r: 0.5; g: 0.5;b: 0.5; a:1. "
		
		"FOG"
		"enable: GL_FOG;
		fogi_pname: GL_FOG_MODE param: GL_EXP2;
		fogfv_pname: GL_FOG_COLOR params: fog_color;
		fogf_pname: GL_FOG_DENSITY param: 0.01;
		hint_target: GL_FOG_HINT mode: GL_DONT_CARE;
		fogf_pname: GL_FOG_START param: 1.0;
		fogf_pname: GL_FOG_END param: 5.0;"
		
		"LIGHT"
		"materialfv_face: GL_FRONT pname: GL_SPECULAR params: specular;
		materialfv_face: GL_FRONT pname: GL_SHININESS  params: shinines;
		lightfv_light: GL_LIGHT0 pname: GL_POSITION params: l_pos;
		lightfv_light: GL_LIGHT0 pname: GL_DIFFUSE params: l_color;
		lightfv_light: GL_LIGHT0 pname: GL_SPECULAR params: l_color;
		lightModelfv_pname: GL_LIGHT_MODEL_AMBIENT params: lmodel_ambient;
		enable: GL_LIGHTING;
		enable: GL_LIGHT0;	"
				
	! !

!SourceCityGLVizualisationBuilder methodsFor: 'buildList' stamp: 'bl 8/1/2012 14:40'!
fillRenderingList: anOpenGLList drawDependencies: aBuilding
	(anOpenGLList = 0)
	ifTrue: [self error: 'wrong declaration'] 
	ifFalse: [
		display bindRenderBuffers.
		self checkSession.
		display gl newList_list: anOpenGLList mode: GL_COMPILE.
		city districts do: [:aDistrict |
			aDistrict buildings do: [:anOtherBuilding |
				(aBuilding dependencies contains: [:building | building = anOtherBuilding name])
				ifTrue: [ 
					(aBuilding district = anOtherBuilding district)
					ifTrue: [self drawSameDistrictLine: aBuilding to: anOtherBuilding] 
					ifFalse: [self drawInterDistrictLine: aBuilding to: anOtherBuilding ] 
					]
				]
			].
		display gl endList.
		].
! !

!SourceCityGLVizualisationBuilder methodsFor: 'buildList' stamp: 'DouailleErwan 7/9/2012 14:24'!
fillRenderingList: anOpenGLList pickingMode: aBoolean 
	(anOpenGLList = 0)
	ifTrue: [self error: 'wrong declaration'] 
	ifFalse: [
		display bindRenderBuffers.
		self checkSession.
		self openglOption: aBoolean not.
		display gl newList_list: anOpenGLList mode: GL_COMPILE.
		display gl translatef_x: 0-(self city dimension x /2) asFloat y: 0 z: 0-(self city dimension z/2) asFloat.
		self drawCityWithPicking: aBoolean.
		display gl endList.
		].! !

!SourceCityGLVizualisationBuilder methodsFor: 'tools' stamp: 'blo 7/5/2012 14:07'!
generateId
	self id: self id +1.
	^ self id! !

!SourceCityGLVizualisationBuilder methodsFor: 'tools' stamp: 'blo 7/9/2012 12:34'!
getElementFor: anId
	^ self idDictionary at: anId ifAbsent: [nil].! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:48'!
glList
	glList ifNil: [self createLists].
	^ glList! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:47'!
glList: anObject

	glList := anObject! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'DouailleErwan 7/12/2012 10:57'!
glListDependencies
	glListDependencies ifNil: [self createDependenciesRenderingList].
	^ glListDependencies! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'DouailleErwan 7/12/2012 10:39'!
glListDependencies: anObject
	glListDependencies := anObject! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:48'!
glListPicking
	glListPicking ifNil: [self createLists].
	^ glListPicking! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:46'!
glListPicking: anObject

	glListPicking := anObject! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:08'!
id

	^ id! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:08'!
id: anObject

	id := anObject! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:08'!
idDictionary

	^ idDictionary! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:08'!
idDictionary: anObject

	idDictionary := anObject! !

!SourceCityGLVizualisationBuilder methodsFor: 'initialize' stamp: 'DouailleErwan 7/12/2012 10:57'!
initialize
	super initialize.
	id := 0.
	self pickingMode: false.
	! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/9/2012 11:49'!
openglOption: aBoolean
	(aBoolean)
	ifTrue: [self enableOpenGLOption] 
	ifFalse: [self disableOpenGLOption]. ! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/4/2012 16:39'!
pickingMode
	^ pickingMode! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/4/2012 16:39'!
pickingMode: anObject
	pickingMode := anObject! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/4/2012 16:39'!
selectedElement
	^ self sourceCityGL selectedElement! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/4/2012 16:39'!
selectedElement: anObject
	^ self sourceCityGL selectedElement: anObject! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/4/2012 16:39'!
sourceCityGL
	^ sourceCityGL! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:25'!
sourceCityGL: anObject
	sourceCityGL := anObject.
	! !

GLViewportMorph subclass: #SourceCityGLVizualisationRenderer
	instanceVariableNames: 'pickingMode sourceCityGL selectedElement dependenciesMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLVizualisationRenderer commentStamp: '<historical>' prior: 0!
My job is simply render the scene!

!SourceCityGLVizualisationRenderer class methodsFor: 'as yet unclassified' stamp: 'blo 7/9/2012 11:58'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL
	! !

!SourceCityGLVizualisationRenderer methodsFor: 'rendering' stamp: 'DouailleErwan 7/30/2012 14:56'!
adaptCameraToMorph.
	self perspectiveFovY: 60.0  
			aspect: (self sourceCityGL width /self sourceCityGL height) asFloat  
			zNear: 1
			zFar: 999999.! !

!SourceCityGLVizualisationRenderer methodsFor: 'rendering' stamp: 'DouailleErwan 7/30/2012 09:47'!
chooseList
	(pickingMode)
		ifTrue: [ self disableLights.
			^self sourceCityGL drawing glListPicking ] 
		ifFalse: [ self enableLights .
			^self sourceCityGL drawing glList ] .! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'DouailleErwan 7/12/2012 11:07'!
depenciesOfSelectedElement
	self selectedElement isNil 
	ifTrue: [ self dependenciesMode: false] 
	ifFalse: [ self dependenciesMode ifTrue: [self dependenciesMode: false] ifFalse: [self dependenciesMode: true] ] ! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'DouailleErwan 7/12/2012 10:29'!
dependenciesMode
	^ dependenciesMode! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'DouailleErwan 7/12/2012 10:29'!
dependenciesMode: anObject
	dependenciesMode := anObject! !

!SourceCityGLVizualisationRenderer methodsFor: 'rendering' stamp: 'DouailleErwan 7/12/2012 15:52'!
disableLights
	display
	gl disable: GL_LIGHTING;
		disable: GL_LIGHT0.! !

!SourceCityGLVizualisationRenderer methodsFor: 'rendering' stamp: 'DouailleErewan 3/16/2012 00:41'!
drawBackGround.	
	display clear:Color white.	
	display gl clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT.
	display gl matrixMode: GL_PROJECTION;
		loadIdentity.
"	display gl clearColor_red: 255
			green:  0 
			blue:  0 alpha: 0;
			clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT;
			matrixMode: GL_PROJECTION; 						
			loadIdentity."! !

!SourceCityGLVizualisationRenderer methodsFor: 'rendering' stamp: 'DouailleErwan 7/30/2012 14:28'!
enableLights
	| gl  lightAmb lightDif lightPos lightSpec lightEmis lightShin i z0 zr0 z1 zr1 x y |
	gl := display gl.
	gl shadeModel: GL_SMOOTH .
				
	lightAmb := NBSourceCityStructRGBA r: 0.5 g: 0.5 b: 0.5 a: 1.
	lightDif := NBSourceCityStructRGBA r: 0.5 g: 0.5 b: 0.5 a: 1.
	lightPos := NBSourceCityStructRGBA r:  sourceCityGL sourceCityConfiguration city dimension x g: 20 b: sourceCityGL sourceCityConfiguration city dimension z a: 1.
	gl
		lightfv_light: GL_LIGHT0 pname: GL_AMBIENT params: lightAmb;
		lightfv_light: GL_LIGHT0 pname: GL_DIFFUSE params: lightDif ;
		lightfv_light: GL_LIGHT0 pname: GL_POSITION params: lightPos;
		enable: GL_LIGHTING;
		enable: GL_LIGHT0.
		
	lightAmb := NBSourceCityStructRGBA r: 1 g: 1 b: 1 a: 1.
	lightDif := NBSourceCityStructRGBA r: 0.5 g: 0.5 b: 0.5 a: 1.
	lightSpec := NBSourceCityStructRGBA r: 0.5 g: 0.5 b: 0.5 a: 1.
	lightEmis := NBSourceCityStructRGBA r: 0 g: 0 b: 0 a: 1.
	lightShin := NBSourceCityStructX x: 100.
	
	gl enable: GL_COLOR_MATERIAL;
		colorMaterial_face: GL_FRONT mode: GL_AMBIENT_AND_DIFFUSE   ;
		materialfv_face: GL_FRONT pname: GL_AMBIENT params:  lightAmb;
		materialfv_face: GL_FRONT pname: GL_DIFFUSE params:  lightDif ;
		materialfv_face: GL_FRONT pname: GL_SPECULAR params:  lightSpec;
		materialfv_face: GL_FRONT pname: GL_SHININESS params: lightShin.
	gl normal3f_nx: 1 ny: 0 nz: 0.
	
	! !

!SourceCityGLVizualisationRenderer methodsFor: 'event handling' stamp: 'DouailleErwan 7/11/2012 12:23'!
handleMouseMove: anEvent
	self controller handleMouseMove: anEvent
! !

!SourceCityGLVizualisationRenderer methodsFor: 'event handling' stamp: 'DouailleErwan 7/11/2012 12:23'!
handlesMouseOver: anEvent
	^ true! !

!SourceCityGLVizualisationRenderer methodsFor: 'event handling' stamp: 'DouailleErwan 7/11/2012 12:23'!
hasKeyboardFocus
	^true.! !

!SourceCityGLVizualisationRenderer methodsFor: 'initialize' stamp: 'DouailleErwan 7/12/2012 10:35'!
initialize
	super initialize.
	self pickingMode: false.
	self dependenciesMode: false.! !

!SourceCityGLVizualisationRenderer methodsFor: 'event handling' stamp: 'DouailleErwan 7/11/2012 12:23'!
mouseEnter: anEvent
	anEvent hand newKeyboardFocus: self! !

!SourceCityGLVizualisationRenderer methodsFor: 'event handling' stamp: 'DouailleErwan 7/11/2012 12:24'!
mouseLeave: anEvent
	anEvent hand newKeyboardFocus: nil! !

!SourceCityGLVizualisationRenderer methodsFor: 'rendering' stamp: 'blo 7/9/2012 12:05'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:58'!
pickingMode

	^ pickingMode! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:58'!
pickingMode: anObject

	pickingMode := anObject! !

!SourceCityGLVizualisationRenderer methodsFor: 'rendering' stamp: 'DouailleErwan 7/17/2012 11:11'!
render
	| list |
	display bindRenderBuffers.
	self checkSession.
	self drawBackGround.		
	self adaptCameraToMorph.
	display gl matrixMode: GL_MODELVIEW; 
		loadIdentity.
	self sourceCityGL camera applyCamera.
	
	display gl
		popMatrix;
		callList: self chooseList;
		flush.
	self selectedElement isNil 
	ifFalse: [
		self sourceCityGL drawing drawCubePicked: self selectedElement.
		self dependenciesMode 
		ifTrue: [
			display gl
				popMatrix;
				callList: self sourceCityGL drawing glListDependencies;
				flush.]
		ifFalse: [self sourceCityGL drawing glListDependencies: nil].
		].! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'DouailleErwan 7/9/2012 15:25'!
selectedElement

	^ selectedElement! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'DouailleErwan 7/12/2012 12:02'!
selectedElement: anObject
	Transcript cr;show:anObject .
	selectedElement := anObject.
	dependenciesMode := false.! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:58'!
sourceCityGL

	^ sourceCityGL! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'DouailleErwan 7/30/2012 11:57'!
sourceCityGL: anObject

	sourceCityGL := anObject.
	! !

NBGLFrameBuffer subclass: #GLFrameBufferForPicking
	instanceVariableNames: 'texId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFrameBufferForPicking commentStamp: '<historical>' prior: 0!
Needed for picking!

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:39'!
attachTexture
	texId := WordArray new: 1.
	
" Create the texture object for the primitive information buffer "
	gl genTextures_n: 1 textures: texId.
	texId := texId at: 1.

	gl bindTexture_target: GL_TEXTURE_2D texture: texId.

	gl texImage2D_target:  GL_TEXTURE_2D level: 0  internalformat:  GL_RGB32UI 
		width: extent x  height: extent y border: 0  format: GL_RGB_INTEGER type: GL_UNSIGNED_INT pixels: nil.
	
	gl framebufferTexture2DEXT_target:  GL_DRAW_FRAMEBUFFER 
		attachment:  GL_COLOR_ATTACHMENT0 
		textarget: GL_TEXTURE_2D 
		texture:  texId  
		level: 0	.
	
	self assert: (gl getError = 0).
	gl bindTexture_target: GL_TEXTURE_2D texture: 0.! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:21'!
createAttachments

		" By default, create a RGBA8 and DEPTH24/STENCIL8 attachments "
	| color depthAndStencil |
	
	self attachTexture.

	
	depthAndStencil := NBGLRenderBuffer gl: gl extent: extent format: GL_DEPTH24_STENCIL8.
	self attach: depthAndStencil as: GL_DEPTH_ATTACHMENT.
	self attach: depthAndStencil as: GL_STENCIL_ATTACHMENT.
	
! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:23'!
resize: newExtent

	"resize a frame buffer"
	extent = newExtent ifTrue: [ ^ self ].
	extent := newExtent.	

	self attachments do: [:renderBuffer | renderBuffer resize: newExtent  ].
	self resizeTexture.
	self checkStatus.

! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:23'!
resizeTexture

	gl bindTexture_target: GL_TEXTURE_2D texture: texId.

	gl texImage2D_target:  GL_TEXTURE_2D level: 0  internalformat:  GL_RGB32UI 
		width: extent x  height: extent y border: 0  format: GL_RGB_INTEGER type: GL_UNSIGNED_INT pixels: nil.
! !

NBExternalStructure variableByteSubclass: #NBSourceCityStructRGBA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!NBSourceCityStructRGBA class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/12/2012 15:11'!
fieldsDesc
  ^ #( 
         NBGLFloat r;
         NBGLFloat g;
         NBGLFloat b;  
	   NBGLFloat a;      
        )! !

!NBSourceCityStructRGBA class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/12/2012 15:13'!
r: r g: g b: b a:a
	^self new r: r;	
		g: g;
		b: b;
		a:a.! !

NBExternalStructure variableByteSubclass: #NBSourceCityStructX
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!NBSourceCityStructX class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/12/2012 15:17'!
fieldsDesc
  ^ #( 
         NBGLFloat x; 
        )! !

!NBSourceCityStructX class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/12/2012 15:18'!
x: x
	^ self new x:x.! !

Object subclass: #Point3D
	instanceVariableNames: 'x y z'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!Point3D commentStamp: '<historical>' prior: 0!
Same than Point but contain another variable wich is z. It use with SourceCity to give correct position in a 3D world!

!Point3D class methodsFor: 'as yet unclassified' stamp: 'blo 7/4/2012 15:58'!
x: x y: y z: z
	^ self new x: x; y: y; z: z; yourself! !

!Point3D methodsFor: 'as yet unclassified' stamp: 'blo 7/5/2012 16:03'!
+ aPoint3D
	^ Point3D x: (x + aPoint3D x) y: (y + aPoint3D y) z: (z + aPoint3D z)! !

!Point3D methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/12/2012 11:47'!
- aPoint3D
	^ Point3D x: (x - aPoint3D x) y: (y - aPoint3D y) z: (z - aPoint3D z)! !

!Point3D methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 8/20/2012 16:11'!
= aPoint3D
	^ (x = aPoint3D x) and: [(y = aPoint3D y) and: [z = aPoint3D z]]! !

!Point3D methodsFor: 'as yet unclassified' stamp: 'blo 7/5/2012 15:15'!
copy
	^ self class x: x y: y z: z! !

!Point3D methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:56'!
x

	^ x! !

!Point3D methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:56'!
x: anObject

	x := anObject! !

!Point3D methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:56'!
y

	^ y! !

!Point3D methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:56'!
y: anObject

	y := anObject! !

!Point3D methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:56'!
z

	^ z! !

!Point3D methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:56'!
z: anObject

	z := anObject! !

Object subclass: #SourceCityGLCamera
	instanceVariableNames: 'lastMousePosition position orientation sourceCityGL'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLCamera commentStamp: '<historical>' prior: 0!
I manage the camera and movements (do not contains key/mouse handler stuff)!

!SourceCityGLCamera class methodsFor: 'as yet unclassified' stamp: 'blo 7/5/2012 15:37'!
initialize: aSourceCityGL camera: aCamera
	
	^self new sourceCityGL: aSourceCityGL; defineDefaultCamera: aCamera! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/30/2012 15:02'!
applyCamera
	self sourceCityGL display gl translatef_x: (self position x) y: (self position y) z: (self position z).  
	
	self sourceCityGL display gl  rotatef_angle: (self orientation x \\360) x: 1 y: 0  z: 0. 
	self sourceCityGL display gl rotatef_angle: (self orientation y \\360) x: 0 y: 1  z: 0. "
	self sourceCityGL display gl rotatef_angle: (self orientation z \\360) x: 0 y: 0  z: 1. 
	 "
! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/30/2012 16:11'!
cameraOnNormal
	self defineDefaultCamera: sourceCityGL sourceCityConfiguration camera.
	 ! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 8/20/2012 14:24'!
cameraOnTop
	self position: (Point3D x: 0 y: 0 z: (0 - self sourceCityGL sourceCityConfiguration city dimension x *8)).
	self orientation: (Point3D x: 90 y: 0 z: 0). ! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:23'!
defineDefaultCamera: aCamera
	orientation := aCamera orientation.
	position := aCamera position.! !

!SourceCityGLCamera methodsFor: 'initialize' stamp: 'blo 7/5/2012 15:17'!
initialize
	super initialize.
	lastMousePosition := Point x: 0 y:0.! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:35'!
lastMousePosition

	^ lastMousePosition! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:35'!
lastMousePosition: anObject

	lastMousePosition := anObject! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:10'!
orientation

	^ orientation! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:10'!
orientation: anObject

	orientation := anObject! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:19'!
position

	^ position! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:19'!
position: anObject

	position := anObject! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/23/2012 14:24'!
rotateDown

	self orientation x: (self orientation x + 3).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/23/2012 14:24'!
rotateLeft

	self orientation y: (self orientation y + 3).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/23/2012 14:23'!
rotateRight

	self orientation y: (self orientation y - 3).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/23/2012 14:23'!
rotateTop

	self orientation x: (self orientation x - 3).
	! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:19'!
sourceCityGL

	^ sourceCityGL! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:37'!
sourceCityGL: anObject

	sourceCityGL := anObject.! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/23/2012 14:23'!
translateBackward

	self position z: (self position z - 30).
	
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/30/2012 15:52'!
translateDown: anObject

	self position y: (self position y + anObject ).! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/30/2012 15:10'!
translateForward

	self position z: (self position z + 30).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/30/2012 15:52'!
translateLeft: anObject

	self position x: (self position x - anObject ).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/30/2012 15:52'!
translateRight: anObject

	self position x: (self position x + anObject ).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/30/2012 15:52'!
translateTop: anObject

	self position y: (self position y - anObject ).
	! !

Object subclass: #SourceCityGLController
	instanceVariableNames: 'sourceCityGL mouseDown senderOfSelectedElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLController commentStamp: '<historical>' prior: 0!
I manage and capture keyboard and mouse events!

!SourceCityGLController class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/21/2012 13:03'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 7/30/2012 15:54'!
captureKey: anEvent
	
	(anEvent keyString = '<left>')
		ifTrue:[self sourceCityGL camera translateRight: 30].
	(anEvent keyString  = '<down>')
		ifTrue:[self sourceCityGL camera translateTop: 30].
	(anEvent keyString  = '<up>')
		ifTrue:[self sourceCityGL camera translateDown: 30].
	(anEvent keyString  = '<right>')
		ifTrue:[self sourceCityGL camera translateLeft: 30].
		
	(anEvent keyString = '<Shift-left>')
		ifTrue:[self sourceCityGL camera translateRight: 3].
	(anEvent keyString  = '<Shift-down>')
		ifTrue:[self sourceCityGL camera translateTop: 3].
	(anEvent keyString  = '<Shift-up>')
		ifTrue:[self sourceCityGL camera translateDown: 3].
	(anEvent keyString  = '<Shift-right>')
		ifTrue:[self sourceCityGL camera translateLeft: 3].
		
	(anEvent keyString  = ' ')
		ifTrue:[self sourceCityGL camera translateForward].
	(anEvent keyString  = 'c' )
		ifTrue:[self sourceCityGL camera translateBackward].
		
	(anEvent keyString  = '<Cmd-w>' )
		ifTrue:[].! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 7/24/2012 13:46'!
captureMouseDown: e
	e buttons = 2 ifTrue: [
		self sourceCityGL renderer pickingMode: true.
		self sourceCityGL renderer render.
		self picking_x: ((e position x) - self sourceCityGL position x) y: ((e position y) - self sourceCityGL position y)."
		self halt."
		self sourceCityGL renderer pickingMode: false.] ! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 7/17/2012 11:25'!
captureMouseStillDown: e
	e buttons = 4 ifTrue: [
		(self sourceCityGL camera  lastMousePosition x > (e position - self sourceCityGL position) x)
			ifTrue: [self sourceCityGL camera  rotateRight].
		(self sourceCityGL camera  lastMousePosition x < (e position - self sourceCityGL  position) x)
			ifTrue:[self sourceCityGL camera  rotateLeft].
		(self sourceCityGL camera  lastMousePosition y < (e position - self sourceCityGL position) y)
			ifTrue:[self sourceCityGL camera  rotateDown].
		(self sourceCityGL camera  lastMousePosition y > (e position - self sourceCityGL position) y)
			ifTrue:[self sourceCityGL camera  rotateTop].
		self sourceCityGL camera  lastMousePosition: (e position - self sourceCityGL position).]! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 7/12/2012 17:44'!
captureMouseWheel: anEvent 
	anEvent direction = #up ifTrue: [
		self sourceCityGL camera translateForward].
	anEvent direction = #down ifTrue: [
		self sourceCityGL camera translateBackward].! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/22/2012 15:29'!
handleMouseMove: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self]. "not interested"
	anEvent wasHandled: true.
	anEvent anyButtonPressed ifTrue: [
		self captureMouseStillDown: anEvent
		].
! !

!SourceCityGLController methodsFor: 'initialize-release' stamp: 'DouailleErwan 7/9/2012 15:24'!
initialize
	super initialize.
	mouseDown:= false.
	senderOfSelectedElement := OrderedCollection new.! !

!SourceCityGLController methodsFor: 'accessing' stamp: 'DouailleErwan 7/9/2012 15:19'!
mouseDown

	^ mouseDown! !

!SourceCityGLController methodsFor: 'accessing' stamp: 'DouailleErwan 7/9/2012 15:19'!
mouseDown: anObject

	mouseDown := anObject! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 7/17/2012 11:26'!
picking_x: x y: y
	|  pixel id tmp |
	pixel := self sourceCityGL display readPixel: x@y.	
	id := (pixel at:1)*256 + (pixel at:2)*256 + (pixel at:3).
	self sendSelectedElement: (self sourceCityGL drawing getElementFor: id).! !

!SourceCityGLController methodsFor: 'accessing' stamp: 'DouailleErwan 7/9/2012 15:22'!
sendSelectedElement: anElement
	self senderOfSelectedElement do: [:aSender | aSender selectedElement: anElement].! !

!SourceCityGLController methodsFor: 'accessing' stamp: 'DouailleErwan 7/9/2012 15:19'!
senderOfSelectedElement

	^ senderOfSelectedElement! !

!SourceCityGLController methodsFor: 'accessing' stamp: 'DouailleErwan 7/9/2012 15:19'!
senderOfSelectedElement: anObject

	senderOfSelectedElement := anObject! !

!SourceCityGLController methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:39'!
sourceCityGL
	^ sourceCityGL! !

!SourceCityGLController methodsFor: 'accessing' stamp: 'DouailleErwan 7/20/2012 15:02'!
sourceCityGL: anObject
	sourceCityGL := anObject.
	senderOfSelectedElement add: anObject renderer.
	senderOfSelectedElement add: anObject userInterface .! !
